# -*-sh-*-
# aolserver.spec, for AOLserver 3.2+ad12 RPM
#
# $Id: aolserver.spec,v 2.2 2001/04/12 20:10:36 biggers Exp $
#
%define release 4

%define version 3.2+ad12
%define versionX 3.2

%define name aolserver
%define directory /usr/local/aolsrv_%{version}

# --------------------------------
Name: %{name}
Version: %{version}
Release: %{release}
Summary: AOLserver 3.2 Web application server
Copyright: MPL
Group: Networking/Daemons
URL: http://www.aolserver.com/
Packager: Mark Biggers <biggers@ivc.com>

Buildroot: /var/tmp/aolsrv
Prefix: %{directory}

Source0: aolserver-3.2+ad12.tar.gz
Source1: bin.tar.gz
Source2: demo.tar.gz
Source3: pgdriver.tar.gz
Source4: README.ivc
Source5: bookbiz.pgres.sql
Source6: index.html
Source7: log-rotate.cron
Source8: Doc.list
Source9: makefile.linux
#SourceN: aolserver_admin.tar.gz
#SourceN: aolserver_c_dev.tar.gz
#SourceN: aolserver_tcl_dev.tar.gz
#SourceN: tcl8_3.tar.gz

Patch0: aol3.2+IVC.patch

Prereq: postgresql-devel, postgresql-server

# --------------------------------
%description
 AOLserver is a multithreaded, Tcl-enabled web server used for large
 scale, dynamic web sites that sports a long list of features.  It is
 the backbone of the largest and busiest production environments in
 the world, including AOL.COM, Digital City, et cetera.
 Visit: http://www.aolserver.com for releases and documentation.
    
 This is an ArsDigita.com distribution of AOLserver 3.2, patch 12.

 Also, we add the 10/03/2000 version of the PostgreSQL driver from 
 http://cvs.sourceforge.net/cgi-bin/cvsweb.cgi/nspostgres, 
 a "production quality" example nsd.server1.tcl, other
 configuration files and some illustrative AOLserver demos,
 in servers/server1/pages/demo/.

 (Do, as root)  %{directory}/bin/server1 start

 (View)    http://localhost.localdomain:8000/doc (documentation)

           http://localhost.localdomain:8000/tests/nstelemetry.adp
	   (see the .adp file, to get the login/password)

           http://localhost.localdomain:8000/demo/[various demos]

 For commercial support, contact steve@ivc.com.  IVC.com also does
 complete Web applications using AOLserver and ArsDigita's application
 services product, ACS.

# --------------------------------
%prep

%setup -T -b 0 -n root

%patch0 -p1

# --------------------------------
%build

%ifarch i686
 CFLAGS="-mpentiumpro -O3"
%else
 CFLAGS="$RPM_OPT_FLAGS"
%endif

POSTGRES=/usr
export POSTGRES CFLAGS

(cd $RPM_SOURCE_DIR 
 if [ ! -f pgdriver.tar.gz ]; then tar -zcf pgdriver.tar.gz  nspostgres; fi)

tar -zxvf $RPM_SOURCE_DIR/pgdriver.tar.gz -C aolserver

cd aolserver

for i in nscache nsrewrite nssha1; do
    ln -s ../${i} .
done

echo "=== build, $PWD ==="

make PREFIX=%{directory}

# --------------------------------
%install

echo "=== make install, $PWD ==="

rm -rf $RPM_BUILD_ROOT

POSTGRES=/usr; export POSTGRES

cd aolserver
make install PREFIX=$RPM_BUILD_ROOT/%{directory}

cwd=`pwd`
blddir=$RPM_BUILD_ROOT/%{directory}

export cwd blddir RPM_BUILD_ROOT RPM_INSTALL_PREFIX

# ---- READMEs, doc/, scripts/

cd ..
tar cf - oracle-driver | tar -xvf - -C $blddir

cd aolserver
tar cf - doc scripts | tar -xvf - -C $blddir

cp -p ChangeLog DISTRIBUTION.txt LICENSE.txt $blddir/doc

tar cf - `cat $RPM_SOURCE_DIR/Doc.list` | tar -xvf - -C $blddir/doc

cp -p $RPM_SOURCE_DIR/makefile.linux | tar -xvf - -C $blddir/oracle-driver

tar cf - tests | tar -xvf - -C $blddir/servers/server1/pages

# ---- SSL, PostgreSQL sample DB, demo/

(cd $RPM_SOURCE_DIR 
  cp -p README.ivc \
    bookbiz.pgres.sql \
    log-rotate.cron \
    nsd.server1.tcl \
    $blddir
  cp -p index.html $blddir/doc
  if [ ! -f demo.tar.gz ]; then tar -zcf demo.tar.gz  demo; fi
  if [ ! -f bin.tar.gz ];  then tar -zc --exclude CVS -f bin.tar.gz  bin; fi)

tar -zxvf $RPM_SOURCE_DIR/bin.tar.gz  -C $blddir

(cd $blddir/servers/server1/pages
  tar -zxvf $RPM_SOURCE_DIR/demo.tar.gz)

# --------------------------------
%clean

rm -rf $RPM_BUILD_ROOT

# --------------------------------
%pre

echo "=== preinst, $PWD ==="

groupadd -f -r devel || :

useradd  -r -d $RPM_INSTALL_PREFIX -s /bin/bash -c "AOLserver.admin" \
  -u 477 -G devel nsadmin || :

# for legacy AOLserver installations...
usermod -g nsadmin -Gdevel nsadmin || :

%post

(cd $RPM_INSTALL_PREFIX/servers/server1/pages
  ln -s $RPM_INSTALL_PREFIX/doc .)

cd $RPM_INSTALL_PREFIX/bin
  cp -p aolserver aolserver.dist
  sed s:/usr/local/aolsrv_3.0:$RPM_INSTALL_PREFIX: aolserver.dist > aolserver

cd $RPM_INSTALL_PREFIX
  cp -p nsd.server1.tcl nsd.server1.tcl.dist
  sed s:/usr/local/aolsrv_3.0:$RPM_INSTALL_PREFIX: nsd.server1.tcl.dist > nsd.server1.tcl
  find . | xargs chown nsadmin.devel
  find . -type d | xargs chmod g+rws

%postun

cd $RPM_INSTALL_PREFIX
  rm -f ./bin/server1 ./bin/aolserver.dist ./nsd.server1.tcl.dist
  rm -f ./servers/server1/pages/doc ./servers/server1/pages/tests

echo "Consider doing: userdel nsadmin"
## if [ $1 = 0 ];  then  userdel nsadmin >/dev/null 2>&1;  fi

# --------------------------------
%files
%defattr(-,nsadmin,devel)
%{directory}
